@echo off
Rem	Install and activate Werefall.

Rem	Usage:  instwere  [dfDirectory]

Rem	where the optional parameter specifies the complete path to
Rem	the Daggerfall installation directory, c:\dagger, by default.

set new=new
set tes2=..
if .%1 == . goto next
	set tes2=%1

:next

Rem	We'd like to log this failure, but since we presently don't
Rem	know exactly where we are, refrain from dropping the log
Rem	file at random on the hard drive.

if exist werefall.pat goto goOn
	echo instwere must be run from the werefall directory.
	goto fini

:goOn
Rem	Note that `o:' is a magic number, not a drive letter.

echo -- Begin Werefall installation:| ncr >>instwere.log
ecr | date | epr o: >>instwere.log
ecr | time | epr o: >>instwere.log
echo Beginning Werefall installation...

Rem	Verify the version patch level of Daggerfall is 213.
Rem	Die if not patch 213.

rochay %tes2%\arena2\verstr.dat verstr.chk >>instwere.log
if errorlevel 1 goto 1gripe
goto original
:1gripe
	echo Installed Daggerfall patch level is not 213. >>instwere.log
	echo Installed Daggerfall patch level is not 213.
	goto fin

:original
echo -- Check for safe-store directories. >>instwere.log
echo honkers >original\honkers
if exist original\honkers goto next1
	echo -- Create directories for Daggerfall safe-store. >>instwere.log
	mkdir original >>instwere.log
	mkdir original\arena2 >>instwere.log
	mkdir new >>instwere.log
	mkdir new\arena2 >>instwere.log
	goto safeStore
:next1
del original\honkers

Rem	Make a virgin installation from the previous safe-store
Rem	This will make `file not found' complaints on the first
Rem	use, but this is normal.

echo -- Restore Daggerfall files from original. >>instwere.log
copy original\*.*        %tes2% >>instwere.log
copy original\arena2\*.* %tes2%\arena2 >>instwere.log

Rem	Safe-store the original contents of the DF installation.

:safeStore
echo -- Safe-store original Daggerfall files in original. >>instwere.log
copy %tes2%\fall.exe           original >>instwere.log
copy %tes2%\arena2\texture.215 original\arena2 >>instwere.log
copy %tes2%\arena2\magic.def   original\arena2 >>instwere.log
copy %tes2%\arena2\faction.txt original\arena2 >>instwere.log
copy %tes2%\arena2\text.rsc    original\arena2 >>instwere.log
copy %tes2%\arena2\$curewer.q* original\arena2 >>instwere.log
copy %tes2%\arena2\q0c00y04.q* original\arena2 >>instwere.log
copy %tes2%\arena2\s0000007.q* original\arena2 >>instwere.log
copy %tes2%\arena2\s0000999.q* original\arena2 >>instwere.log

Rem	Extract images from 389 and 386

e389 <%tes2%\arena2\texture.389 >new\t389.img
if errorlevel 1 goto 3gripe
goto 1ok
:3gripe
	echo Texture 389 could not be extracted. >>instwere.log
	echo Texture 389 could not be extracted.
	goto fin

:1ok
e396 <%tes2%\arena2\texture.396 >new\t396.img
if errorlevel 1 goto 4gripe
goto 2ok
:4gripe
	echo Texture 396 could not be extracted. >>instwere.log
	echo Texture 396 could not be extracted.
	goto fin

:2ok
Rem	Patch the necessary binaries.

echo -- Build new versions in new. >>instwere.log
rochay - werefall.pat >>instwere.log
if errorlevel 1 goto 2gripe
goto ok
:2gripe
	echo Werefall has not been activated. >>instwere.log
	echo Werefall has not been activated.
	goto fin

:ok
echo -- Merge texture headers with images. >>instwere.log
cd new
copy /b t215.hdr+..\t215.img+t389.img+t396.img arena2\texture.215 >>..\instwere.log
cd ..

Rem	Replicate the known quests to fill in the gaps for
Rem	the scheduler.

echo -- Replicate quests to fill scheduler slots. >>instwere.log
cd arena2
for %%i in (65   ) do copy s0000975.* s00009%%i.* >>..\instwere.log
for %%i in (64 61) do copy s0000974.* s00009%%i.* >>..\instwere.log
rem for %%i in (66   ) do copy s0000973.* s00009%%i.* >>..\instwere.log
for %%i in (62) do copy s0000972.* s00009%%i.* >>..\instwere.log
for %%i in (63   ) do copy s0000971.* s00009%%i.* >>..\instwere.log
rem for %%i in (64 61) do copy s0000970.* s00009%%i.* >>..\instwere.log
cd ..

Rem	Promote the changes.

echo -- Promote the new changes. >>instwere.log
copy new\fall.exe %tes2% >>instwere.log
copy new\arena2 %tes2%\arena2 >>instwere.log

Rem	Install the new quests.

copy arena2 %tes2%\arena2 >>instwere.log
echo Werefall has been activated. >>instwere.log
echo Werefall has been activated.

:fin
echo -- End Werefall installation:| ncr >>instwere.log
ecr | date | epr o: >>instwere.log
ecr | time | epr o: >>instwere.log

:fini
